<?php
/**
 * @file
 * Provide an ws slideshow style plugin for Views.
 *
 */

/**
 * Implements views_plugin_style().
 */
class views_plugin_style_ws_slideshow extends views_plugin_style {
  /**
   * Set default options.
   */
  public function option_definition() {
    $options = parent::option_definition();
    $options['uses_fields'] = array('default' => 1);
    $options['ws_slideshow_width'] = array('default' => 630);
    $options['ws_slideshow_height'] = array('default'=> 450);
    $options['ws_slideshow_description'] = array('default' => t('Description here'));
    
    return $options;
  }

  /**
   * {@inheritdoc}
   */
  public function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);
    // need to be enabled, remove user access
    $form['uses_fields']['#access'] = FALSE;

    $form['ws_slideshow_width'] = array(
      '#type' => 'textfield',
      '#title' => t('Width of WS Slideshow'),
      '#default_value' => $this -> options['ws_slideshow_width'],
      '#size' => 4,
      '#required' => TRUE,
    );
    $form['ws_slideshow_height'] = array(
      '#type' => 'textfield',
      '#title' => t('Height of WS Slideshow'),
      '#default_value' => $this -> options['ws_slideshow_height'],
      '#size' => 4,
      '#required' => TRUE,
    );
    $form['ws_slideshow_description'] = array(
      '#type' => 'textarea',
      '#title' => t('Description'),
      '#description' => t('Description of the slideshow.'),
      '#default_value' => $this -> options['ws_slideshow_description'],
    );
  }

  /**
   * pre_render() necesary to prevent markup mayhem.
   */
  public function pre_render($result) {
    // create/update file views selection
    ws_slideshow_create_views_list($this -> view);
  }

  /**
   * Render the display in this style.
   */
  public function render() {
    $output = _ws_slideshow_views_output($this -> view);

    return $output;
  }
}
